/*
    Deprecated Decorator v0.1
    https://github.com/vilic/deprecated-decorator
*/
/** @internal */
exports.options = {
    getWarner: undefined
};
function createWarner(type, name, alternative, version, url) {
    var warnedPositions = {};
    return function () {
        var stack = (new Error()).stack || '';
        var at = (stack.match(/(?:\s+at\s.+){2}\s+at\s(.+)/) || [])[1];
        if (/\)$/.test(at)) {
            at = at.match(/[^(]+(?=\)$)/)[0];
        }
        else {
            at = at.trim();
        }
        if (at in warnedPositions) {
            return;
        }
        warnedPositions[at] = true;
        var message = (type === 'property' ? 'Property or method' : 'Class') + " \"" + name + "\" has been deprecated";
        if (version) {
            message += " since version " + version;
        }
        if (alternative) {
            message += ", use \"" + alternative + "\" instead";
        }
        message += '.';
        message += "\n    at " + at;
        if (url) {
            message += "\nCheck out " + url + " for more information.";
        }
        console.warn(message);
    };
}
exports.createWarner = createWarner;
function decorateProperty(type, name, descriptor, alternative, version, url) {
    var warner = (exports.options.getWarner || createWarner)(type, name, alternative, version, url);
    descriptor = descriptor || {
        writable: true,
        enumerable: false,
        configurable: true
    };
    var deprecatedDescriptor = {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable
    };
    if (descriptor.get || descriptor.set) {
        if (descriptor.get) {
            deprecatedDescriptor.get = function () {
                warner();
                return descriptor.get.call(this);
            };
        }
        if (descriptor.set) {
            deprecatedDescriptor.set = function (value) {
                warner();
                return descriptor.set.call(this, value);
            };
        }
    }
    else {
        var propertyValue = descriptor.value;
        deprecatedDescriptor.get = function () {
            warner();
            return propertyValue;
        };
        if (descriptor.writable) {
            deprecatedDescriptor.set = function (value) {
                warner();
                propertyValue = value;
            };
        }
    }
    return deprecatedDescriptor;
}
function decorateClass(target, alternative, version, url) {
    var name = target.name;
    var warner = (exports.options.getWarner || createWarner)('class', name, alternative, version, url);
    var constructor = function () {
        warner();
        target.apply(this, arguments);
    };
    Object.defineProperty(constructor, 'name', {
        value: name,
        writable: false
    });
    for (var _i = 0, _a = Object.getOwnPropertyNames(target); _i < _a.length; _i++) {
        var propertyName = _a[_i];
        var descriptor = Object.getOwnPropertyDescriptor(target, propertyName);
        if (descriptor.writable) {
            constructor[propertyName] = target[propertyName];
        }
        else if (descriptor.configurable) {
            Object.defineProperty(constructor, propertyName, descriptor);
        }
    }
    return constructor;
}
function deprecated(alternative, version, url) {
    return function (target, name, descriptor) {
        if (typeof name === 'string') {
            return decorateProperty('property', name, descriptor, alternative, version, url);
        }
        else if (typeof target === 'function') {
            var constructor = decorateClass(target, alternative, version, url);
            for (var _i = 0, _a = Object.getOwnPropertyNames(constructor); _i < _a.length; _i++) {
                var propertyName = _a[_i];
                var descriptor_1 = Object.getOwnPropertyDescriptor(constructor, propertyName);
                descriptor_1 = decorateProperty('class', target.name, descriptor_1, alternative, version, url);
                if (descriptor_1.writable) {
                    constructor[propertyName] = target[propertyName];
                }
                else if (descriptor_1.configurable) {
                    Object.defineProperty(constructor, propertyName, descriptor_1);
                }
            }
            return constructor;
        }
    };
}
exports.deprecated = deprecated;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = deprecated;
//# sourceMappingURL=index.js.map